/** @type {import('./$types').Actions} */
import {initDb} from '$lib/db/db.js';
import {auth} from '$lib/db/auth.js';
const db = await initDb();

/** @type {import('./$types').RequestHandler} */
export async function POST(event) { 
        var user = await auth(event,db);
        if (!user) return new Response('authfail');

        const dat = await event.request.formData(); 
        var name = '';
        dat.forEach(async (file, key) => {
            if (key == 'invite') {
                name = file.trim();
            }
        });

        var hub = await db.all("SELECT hub FROM hub WHERE invite = ?",name);

        if (!hub || hub.length < 1) return new Response('nohub');

        await db.run("DELETE FROM hubpairs WHERE hub = ? AND user = ?",hub[0].hub,user);
        await db.run("INSERT INTO hubpairs (hub,user) VALUES (?,?)",hub[0].hub,user);


        return new Response('success');
};

