/** @type {import('./$types').Actions} */
import {auth} from '$lib/db/auth.js';
import {initDb} from '$lib/db/db.js';
import {writeFileSync} from 'fs';
import {randomBytes} from 'crypto';
const db = await initDb();

/** @type {import('./$types').RequestHandler} */
export async function POST(event) { 
        var user = await auth(event,db);
        if (!user) return new Response('authfail');

        const dat = await event.request.formData(); 
        var name = '';
        dat.forEach(async (file, key) => {
            if (key == 'name') {
                name = file.trim();
            }
        });

        if (name.length > 64) return new Response('long');
    

        const userTest = new RegExp("^[A-Za-z0-9_ -]+$");
        if (!userTest.test(name)) return new Response('invalid');

        var hubs = await db.all("SELECT hub FROM hubpairs WHERE hub = ?",name);

        if (hubs && hubs.length > 0) return new Response('hubexists');

        const file = '';
        dat.forEach(async (file, key) => {
            if (key == 'img' && file.arrayBuffer) {
                writeFileSync(`${process.cwd()}/../space-data/hub/${name}.png`, Buffer.from(await file.arrayBuffer()));
            }
        });
        
        var invite = randomBytes(16).toString('hex');
        
        await db.run("INSERT INTO hubpairs (hub,user) VALUES (?,?)",name,user);
        await db.run("INSERT INTO hub (hub,invite) VALUES (?,?)",name,invite);


        return new Response('success');
};

